# This file is part of pyDC software
# Copyright 2002-2004 Anakim Border <aborder@users.sourceforge.net>
#
# pyDC is released under the terms of GPL licence.

from EventGenerator import *
import wx

class JobViewer(wx.Panel, EventGenerator):
	def __init__(self, parent, id, info):
		wx.Panel.__init__(self, parent, id)
		EventGenerator.__init__(self)
		self.info = info
		
		job = self.info.getJob()
		if isinstance(job, EventGenerator):
			job.registerListener(self)
	
	def viewerDestroy(self, stopJob):
		job = self.info.getJob()
		if isinstance(job, EventGenerator):
			job.deregisterListener(self)
		if stopJob: job.stop()
	
		#TODO: what about multiple interfaces?
		self.lock.acquire()
		for listener in self.getListeners():
			listener.onViewerClosed(self, stopJob)
		self.lock.release()
		
		try: wx.Yield()
		except wx.PyAssertionError: pass
		self.Destroy()
	
	def getTitle(self):
		pass
		
	def getInfo(self):
		return self.info

	def update(self):
		pass
