# This file is part of pyDC software
# Copyright 2004 Anakim Border <aborder@users.sourceforge.net>
#
# pyDC is released under the terms of GPL licence.

import wx

class MultirowMessage(wx.Dialog):
	def __init__(self, parent, nick = None):
		if nick:
			title = 'Message to: %s' % nick
		else:
			title = 'Message'
		
		wx.Dialog.__init__(self, parent, -1, title, style = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER)
		
		self.msg = wx.TextCtrl(self, 1, style = wx.TE_MULTILINE | wx.TE_WORDWRAP)
		
		hbs = wx.BoxSizer(wx.HORIZONTAL)
		hbs.Add(wx.Button(self, wx.ID_OK, 'OK'), 1, wx.EXPAND | wx.RIGHT, 5)
		hbs.Add(wx.Button(self, wx.ID_CANCEL, 'Cancel'), 1, wx.EXPAND)
		
		vbs = wx.BoxSizer(wx.VERTICAL)
		vbs.Add(self.msg, 1, wx.EXPAND | wx.TOP | wx.BOTTOM | wx.LEFT | wx.RIGHT, 2)
		vbs.Add(hbs, 0, wx.EXPAND | wx.TOP | wx.BOTTOM | wx.LEFT | wx.RIGHT, 2)
		self.SetSizer(vbs)
		
		wx.EVT_KEY_DOWN(self.msg, self.onChar)

	def onChar(self, event):
		if event.ControlDown() and event.GetKeyCode() == wx.WXK_RETURN:
			self.EndModal(wx.ID_OK)
		event.Skip()
	
	def GetValue(self):
		return self.msg.GetValue()
