# This file is part of pyDC software
# Copyright 2002-2004 Anakim Border <aborder@users.sourceforge.net>
#
# pyDC is released under the terms of GPL licence.

from bz2 import BZ2File
from he3 import *
from os import unlink
from os.path import isfile

from DCFileList import *
import DCWorker

class DCLocalListWriter:
	def write(list):
		s = ''
		for i in list.getList():
			s += DCLocalListWriter.writeItem(i)

		w = DCWorker.getWorker()
		
		f = file(w.FILELIST_HE3, 'wb')
		f.write(He3Encoder().encode(s))
		f.close()
		
		f = BZ2File(w.FILELIST_BZ2, 'w')
		f.write(s)
		f.close()
	
	def cleanup():
		w = DCWorker.getWorker()
		for i in (w.FILELIST_HE3, w.FILELIST_BZ2):
			if isfile(i): unlink(i)
	
	###################
	# Private members #
	###################

	def writeItem(item, level = 0):
		s = ''
		for i in range(level): s += '\t'
		
		if item[3]: #dir
			s += '%s\r\n' % item[0]
			for c in item[3]:
				s += DCLocalListWriter.writeItem(c, level+1)
		else:
			s += '%s|%d\r\n' % (item[0], item[1])
		
		return s
	
	write = staticmethod(write)
	cleanup = staticmethod(cleanup)
	writeItem = staticmethod(writeItem)
