# This file is part of pyDC software
# Copyright 2002-2003 Anakim Border <aborder@users.sourceforge.net>
#
# pyDC is released under the terms of GPL licence.

from Job import *
from socket import socket, error, AF_INET, SOCK_DGRAM

class DCSearchListener(object, Job):
	def __init__(self, port, worker):
		self.sock = socket(AF_INET, SOCK_DGRAM)
		self.sock.bind(('0.0.0.0', port))
		self.sock.setblocking(0)
		
		self.worker = worker

	def poll(self):
		try:
			while True:
				data, addr = self.sock.recvfrom(2048)
				if data[:3] == '$SR':
					self.worker.parseResult(data[4:])
		except error:
			pass

	def stop(self):
		if self.isAlive():
			self.sock.close()
			self.poll = self.stoppedPoll

	def isAlive(self):
		return self.poll != self.stoppedPoll

	#=================#
	# Private section #
	#=================#

	def stoppedPoll(self):
		return True

	#def isWouldBlock(self, code):
	#	if os.name == "posix":
	#		if code in (errno.EAGAIN, errno.EALREADY, errno.EINPROGRESS, errno.EINTR):
	#			return True
	#	elif os.name == "nt":
	#		if code == errno.WSAEWOULDBLOCK:
	#			return True
	#	return False
