# This file is part of pyDC software
# Copyright 2002-2004 Anakim Border <aborder@users.sourceforge.net>
#
# pyDC is released under the terms of GPL licence.

class DCUser(object):
	CONN_NONE      = -1
	CONN_28K       =  0
	CONN_33K       =  1
	CONN_56K       =  2
	CONN_MODEM     =  3
	CONN_ISDN      =  4
	CONN_WIRELESS  =  5
	CONN_MICROWAVE =  6
	CONN_SATELLITE =  7
	CONN_DSL       =  8
	CONN_CABLE     =  9
	CONN_T1        = 10
	CONN_T3        = 11
	
	CONN_NAMES = { CONN_NONE      : 'Unknown',
	               CONN_28K       : '28.8Kbps',
	               CONN_33K       : '33.6Kbps',
	               CONN_56K       : '56Kbps',
	               CONN_MODEM     : 'Modem',
	               CONN_ISDN      : 'ISDN',
	               CONN_WIRELESS  : 'Wireless',
	               CONN_MICROWAVE : 'Microwave',
	               CONN_SATELLITE : 'Satellite',
	               CONN_DSL       : 'DSL',
	               CONN_CABLE     : 'Cable',
	               CONN_T1        : 'LAN(T1)',
	               CONN_T3        : 'LAN(T3)' }
	
	STATUS_DEFAULT = 1
	STATUS_FILESERVER = 4
	STATUS_SPEEDUSER = 8
	STATUS_AWAY_FLAG = 2
	
	__slots__ = ('op', 'nick', 'share', 'description', 'connection', 'status', 'email', 'hub')
	
	def __init__(self):
		self.op = 0
		self.nick = None
		self.share = long(-1)
		self.description = None
		self.connection = self.CONN_NONE
		self.status = -1
		self.email = None

	def isOp(self):
		return self.op

	def getNick(self):
		return self.nick

	def getShare(self):
		return self.share

	def getDescription(self):
		return self.description

	def getConnection(self):
		return self.connection

	def getEmail(self):
		return self.email

	def getHub(self):
		return self.hub
		
	def __str__(self):
		s  = "=== DCUser ===\n"
		s += "Op: " + `self.op` + "\n"
		s += "Nick: " + self.nick + "\n"
		s += "Share: " + `self.share` + "\n"
		s += "Description: "
		if self.description != None: s + self.description
		s += "\n"
		s += "Connection: " + `self.connection` + "\n"
		s += "Status: " + `self.status` + "\n"
		s += "Email: "
		if self.email != None: s = s + self.email
		s += "\n"
		s += "Hub: "
		if self.hub != None: s = s + self.hub.getName()
		
		return s
