# This file is part of pyDC software
# Copyright 2002-2003 Anakim Border <aborder@users.sourceforge.net>
#
# pyDC is released under the terms of GPL licence.

from AsyncSocket import AsyncSocket
from Job import *
from socket import socket, error, AF_INET, SOCK_STREAM, SOL_SOCKET, SO_REUSEADDR

from DCXfer import DCXfer
import DCWorker

class DCXferListener(object, Job):
	def __init__(self, port):
		self.sock = socket(AF_INET, SOCK_STREAM)
		self.sock.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
		self.sock.bind(('0.0.0.0', port))
		self.sock.listen(3)
		self.sock.setblocking(0)

	def poll(self):
		try:
			conn, addr = self.sock.accept()
			DCWorker.getWorker().addJob(DCXfer(True, AsyncSocket(conn)))
		except error: pass
		return False

	def stop(self):
		if self.isAlive():
			self.sock.close()
			self.poll = self.stoppedPoll

	def isAlive(self):
		return self.poll != self.stoppedPoll

	#=================#
	# Private section #
	#=================#

	def stoppedPoll(self):
		return True

