# This file is part of pyDC software
# Copyright 2003 Anakim Border <aborder@users.sourceforge.net>
#
# pyDC is released under the terms of GPL licence.

class Tokenizer:
	def __init__(self, string):
		self.data = string

	def hasMore(self):
		return self.data != None

	def next(self, delimiter = ' '):
		if self.data == None:
			raise ValueError
	
		pos = self.data.find(delimiter)
		if pos >= 0:
			token = self.data[:pos]
			self.data = self.data[pos+len(delimiter):]
			
			if len(self.data) == 0:
				self.data = None
		else:
			token = self.data
			self.data = None

		return token

	def flush(self):
		data = self.data
		self.data = None
		return data
